/*
 Author: Nikolay Litvinov
 Script: Views+zoom Created in the 3dsMax 2012
 Now is not necessary to press the Zoom Extents Selected, 
 when switching of view
 Tip:  Assign these scripts to buttons of num-pad.
*/
macroScript zv_F category:"Views+zoom" tooltip: "Front"
(
	max vpt front
	max zoomext sel
	try(unhide $F)catch()
	try(hide $T) catch()
	try(hide $B) catch()
	try(hide $L) catch()
)

macroScript zv_B category:"Views+zoom" tooltip: "Back"
(
	max vpt back
	max zoomext sel
	try(unhide $B)catch()
	try(hide $T) catch()
	try(hide $F) catch()
	try(hide $L) catch()
)

macroScript zv_Bot category:"Views+zoom" tooltip: "Bottom"
(
	max vpt bottom
	max zoomext sel
)

macroScript zv_T category:"Views+zoom" tooltip: "Top"
(
	max vpt top
	max zoomext sel
	try(unhide $T)catch()
	try(hide $B) catch()
	try(hide $F) catch()
	try(hide $L) catch()
)

macroScript zv_L category:"Views+zoom" tooltip: "Left"
(
	max vpt left
	max zoomext sel
	try(unhide $L)catch()
	try(hide $T) catch()
	try(hide $F) catch()
	try(hide $B) catch()
)

macroScript zv_R category:"Views+zoom" tooltip: "Right"
(
	max vpt right
	max zoomext sel
	try(unhide $L)catch()
	try(hide $T) catch()
	try(hide $F) catch()
	try(hide $B) catch()
)

macroScript zv_PerspOrthViSw Category:"Views+zoom" Tooltip:"Perspective-Orthographic View Switcher" icon:#("ViewportNavigationControls",26)
(
on ischecked return gw.isPerspectiveView()
	on Execute do
if gw.isPerspectiveView()==on
then
	if ViewCubeOps.Visibility==on
	then (ViewCubeOps.Orthographic(); max zoomext sel
		  actionMan.executeAction 0 "550"  -- Views: Viewport Visual Style Shaded
	try(hide $L)catch()
	try(hide $T)catch()
	try(hide $F)catch()
	try(hide $B)catch()
		)
	else (ViewCubeOps.Orthographic(); max zoomext sel; ViewCubeOps.Visibility=off
		  actionMan.executeAction 0 "550"  -- Views: Viewport Visual Style Shaded
	try(hide $L)catch()
	try(hide $T)catch()
	try(hide $F)catch()
	try(hide $B)catch()
		)
else
	if ViewCubeOps.Visibility==on
	then (ViewCubeOps.Perspective(); max zoomext sel
		  actionMan.executeAction 0 "550"  -- Views: Viewport Visual Style Shaded
	try(hide $L)catch()
	try(hide $T)catch()
	try(hide $F)catch()
	try(hide $B)catch()
		 )
	else (ViewCubeOps.Perspective(); max zoomext sel; ViewCubeOps.Visibility=off
		  actionMan.executeAction 0 "550"  -- Views: Viewport Visual Style Shaded
	try(hide $L)catch()
	try(hide $T)catch()
	try(hide $F)catch()
	try(hide $B)catch()
		)
Completeredraw()
)

fn WorldToScreenPos p =
	(
		local screen_width = RenderWidth
		local screen_height = RenderHeight
		local thePos = p * viewport.getTM()
		local screen_origin = mapScreenToView [0,0] (thePos.z) [screen_width,screen_height]
		local end_screen = mapScreenToView [screen_width,screen_height] (thePos.z) [screen_width,screen_height]
		local world_size = screen_origin-end_screen
		local x_aspect = screen_width/(abs world_size.x)
		local y_aspect = screen_height/(abs world_size.y)
		local screen_coords = point2 (x_aspect*(thePos.x-screen_origin.x)) (-(y_aspect*(thePos.y-screen_origin.y)))
		return screen_coords
	)


fn GetKnot_Pos_fn=
(
global PointPos=#()
for spl=1 to numSplines $ do
for k=1 to (getKnotSelection $ spl).count
do append PointPos (getKnotPoint $ spl ((getKnotSelection $ spl)[k]))
)

fn FN_Seg_2_Knot_Ctrl_1 = 
(
arSegKnots=for spl=1 to numSplines $ collect  getSegSelection $ spl
	for i=1 to arSegKnots.count where arSegKnots[i].count!=0 do
	for j=1 to arSegKnots[i].count  do appendIfUnique arSegKnots[i] (arSegKnots[i][j]+1)
	for i=1 to arSegKnots.count do if arSegKnots[i].count>numKnots $ i do deleteItem arSegKnots[i] arSegKnots[i].count
	for spl=1 to arSegKnots.count do
	setKnotSelection $ spl arSegKnots[spl]
	--subObjectLevel=1
)

fn Normal_fromBorder_fn=(macros.run "Editable Polygon Object" "EPoly_Cap"
with undo off gco.ConvertSelection #Border #Face requireAll:on
local n=polyOp.getFaceNormal s1 (gco.getselection #face as array)[1]
max undo; n)

macroScript zv_X_Align_Viewport_subobject category:"Views+zoom" tooltip: "X Align Viewport by subobject"
(
global s1=selection[1]
global PointPos=#()
global Normal_Face
fn Align12_fn=(-- HorizontView_Edge_or_2Vert
	if selection.count==1 do
(
	global gco=modPanel.getCurrentObject()
	if	classof $==SplineShape or classof $==line 
	then case subobjectlevel of
			(
				1: GetKnot_Pos_fn()
				2: (FN_Seg_2_Knot_Ctrl_1(); GetKnot_Pos_fn())
			)
	else PointPos = case subobjectlevel of
			(
				1: (vert=getVertSelection s1.mesh as array; if vert.count>0 do for i=1 to 2 collect getPointPos s1 vert[i])
				2: (vert=(PolyOp.GetVertsUsingEdge s1 (gco.getSelection #Edge)) as array; if vert.count>0 do for i=1 to 2 collect getPointPos s1 vert[i])
			)
)
		fn ViewTransformTM=(
			p1 = WorldToScreenPos PointPos[2]
			p2 = WorldToScreenPos PointPos[1]
			vec = normalize (p1 - p2)
			horizont = [1,0,0]
			ang = acos (dot [vec.x,vec.y,0] horizont)
			if p1.y <= p2.y then ang *= (-1)
			if ang < -135 do ang=180+ang
			if ang > 135 do ang=ang-180
			viewport.SetTM ((viewport.GetTM()) * RotateZMatrix ang)
			--vectViewport = (inverse(getViewTM())).row3
			--rotate s1 (angleaxis ang vectViewport)
			)
		------------------SCRIPT---------------------
				viewport.setType #view_iso_user
				ViewTransformTM()
		)
fn Align_byFace_fn=
(
WorldUpVector	= [0,0,1]
Tangent_Face	= normalize (cross WorldUpVector Normal_Face)
tempcam = freecamera pos:Tangent_Face
tempcam.dir =Tangent_Face
MatrixView=inverse tempcam.transform
viewport.setTM MatrixView
delete tempcam
select s1
max zoomext sel
)
	case subobjectlevel of
	(	
	1: Align12_fn()
	2: Align12_fn()
	3: (Normal_Face = Normal_fromBorder_fn(); Align_byFace_fn())
	4: (Normal_Face	= polyOp.getFaceNormal s1 (gco.getselection #face as array)[1]; Align_byFace_fn())
	)
Completeredraw()
)

macroScript zv_Y_Align_Viewport_subobject category:"Views+zoom" tooltip: "Y Align Viewport by subobject"
(
global s1=selection[1]
global PointPos=#()
global Normal_Face
fn Align12_fn=
	(-- HorizontView_Edge_or_2Vert
	if selection.count==1 do
(
	global gco=modPanel.getCurrentObject()
	if	classof $==SplineShape or classof $==line 
	then case subobjectlevel of
		(
		1: GetKnot_Pos_fn()
		2: (FN_Seg_2_Knot_Ctrl_1(); GetKnot_Pos_fn())
		)
	else PointPos = case subobjectlevel of
		(
		1: (vert=getVertSelection s1.mesh as array; if vert.count>0 do for i=1 to 2 collect getPointPos s1 vert[i])
		2: (vert=(PolyOp.GetVertsUsingEdge s1 (gco.getSelection #Edge)) as array; if vert.count>0 do for i=1 to 2 collect getPointPos s1 vert[i])
		)
)

	fn ViewTransformTM=(
		p1 = WorldToScreenPos PointPos[2]
		p2 = WorldToScreenPos PointPos[1]
		vec = normalize (p1 - p2)
		horizont = [1,0,0]
		ang = acos (dot [vec.x,vec.y,0] horizont)
		if p1.y <= p2.y then ang *= (-1)
		ang=ang-90
		viewport.SetTM ((viewport.GetTM()) * RotateZMatrix ang)
		--vectViewport = (inverse(getViewTM())).row3
		--rotate s1 (angleaxis ang vectViewport)
		)
		------------------SCRIPT---------------------
				viewport.setType #view_iso_user
				ViewTransformTM()
	)

fn Align_byFace_fn=(
WorldUpVector	= [0,0,1]
Tangent_Face	=	normalize (cross WorldUpVector Normal_Face)
Binormal_Face	=	normalize (cross Tangent_Face Normal_Face)
tempcam = freecamera pos: Binormal_Face
tempcam.dir =Binormal_Face
MatrixView=inverse tempcam.transform
viewport.setTM MatrixView
delete tempcam
select s1
max zoomext sel
)
	case subobjectlevel of
	(	
	1: Align12_fn()
	2: Align12_fn()
	3: (Normal_Face = Normal_fromBorder_fn(); Align_byFace_fn())
	4: (Normal_Face	= polyOp.getFaceNormal s1 (gco.getselection #face as array)[1]; Align_byFace_fn())
	)
Completeredraw()
)


macroScript zv_Z_Align_Viewport_subobject category:"Views+zoom" tooltip: "Z Align Viewport by subobject"
(
global s1=selection[1]
global PointPos=#()
if selection.count==1 do
(
	global gco=modPanel.getCurrentObject()
	if	classof $==SplineShape or classof $==line
	then case subobjectlevel of
		(
			1: GetKnot_Pos_fn()
			2: (FN_Seg_2_Knot_Ctrl_1(); GetKnot_Pos_fn())
		)
	else PointPos = case subobjectlevel of
		(
			1: (vert=getVertSelection s1.mesh as array; if vert.count>0 do for i=1 to 2 collect getPointPos s1 vert[i])
			2: (vert=(PolyOp.GetVertsUsingEdge s1 (gco.getSelection #Edge)) as array; if vert.count>0 do for i=1 to 2 collect getPointPos s1 vert[i])
		)
)
Normal_Face=case subobjectLevel of
(
1: normalize (PointPos[2] - PointPos[1])
2: normalize (PointPos[2] - PointPos[1])
3: Normal_fromBorder_fn()
4: polyOp.getFaceNormal s1 (gco.getselection #face as array)[1]
)

tempcam = freecamera pos: Normal_Face
tempcam.dir=Normal_Face
MatrixView=inverse tempcam.transform
viewport.setTM MatrixView
delete tempcam
select s1
max zoomext sel
Completeredraw()
)


macroScript	zv_ObjRotation_by_Edge_2Vert_View	category:"Views+zoom"	toolTip:"OBJECT Rotation by Edge/2Vert = View"	--icon:#("",1)
(
global s1=selection[1]
global PointPos=#()
	if selection.count==1 do
		if	classof $==SplineShape or classof $==line 
		then case subobjectlevel of
				(
					1: GetKnot_Pos_fn()
					2: (FN_Seg_2_Knot_Ctrl_1(); GetKnot_Pos_fn())
				)
		else PointPos = case subobjectlevel of
				(
					1: (vert=getVertSelection s1.mesh as array; if vert.count>0 do for i=1 to 2 collect getPointPos s1 vert[i])
					2: (vert=(PolyOp.GetVertsUsingEdge s1 (polyop.getEdgeSelection s1)) as array; if vert.count>0 do for i=1 to 2 collect getPointPos s1 vert[i])
				)
		fn ViewTransformTM=(
		p1 = WorldToScreenPos PointPos[2]
		p2 = WorldToScreenPos PointPos[1]
		vec = normalize (p1 - p2)
		horizont = [1,0,0]
		ang = acos (dot [vec.x,vec.y,0] horizont)
		if p1.y <= p2.y then ang *= (-1)
		if ang < -135 do ang=180+ang
		if ang > 135 do ang=ang-180
		--viewport.SetTM ((viewport.GetTM()) * RotateZMatrix ang)
		vectViewport = (inverse(getViewTM())).row3
		rotate s1 (angleaxis ang vectViewport)
		)
		sLevel=subobjectLevel
		suspendediting()
		ResetXForm s1; if converttosplineshape s1==undefined do converttopoly s1
		with redraw off ViewTransformTM()
		ResetXForm s1; if converttosplineshape s1==undefined do converttopoly s1
		resumeediting()
		subobjectLevel = sLevel
		ok
)